/*************************************************************************/
/*************************************************************************/
/*                                                                       */
/*  File Name : TSP_GA.h                                                 */
/*                                                                       */
/*       Date : November  6, 1997                                        */
/* Updated at : November  6, 1997                                        */
/*                                                                       */
/*************************************************************************/
/*************************************************************************/

#ifndef _TSP_GA_
#define _TSP_GA_

#include "global.h"
#include "gene.h"
#include "chromo.h"
#include "pop.h"
#include "EdgeGraph.h"
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <time.h>


struct struct_Info_TSP_GA
{
           int  popSize ;
           int  generations ;
           int  migrationTime ;
         float  crossover ;
  enum cross_t  crossoverType ;
         float  mutation ;
 enum delete_t  deletionType ;
           int  elitismValue ;
enum fitness_t  fitnessType ;
        eval_t  fitnessParam ;
  unsigned int  chromoLength;
          char  dataFile[nameLength]; 
};

struct struct_TSP_GA
{
        int  popSize ;
        int  generations ;
      float  crossover ;
    enum cross_t  crossoverType ;
      float  mutation ;
   enum delete_t  deletionType ;
        int  elitismValue ;
  enum fitness_t  fitnessType ;
     eval_t  fitnessParam ;
        int  seed ;
       type_Gene  **genePool;
unsigned int  chromoLength;
       type_Population *myPop;
       char  *dataFile; 

  type_EdgeGraph  *edgeGraph;
 
};

typedef struct struct_TSP_GA type_TSP_GA;


type_TSP_GA* defineTSP_GA(char *dataFile,int popSize, int generations, float crossover, 
	          enum cross_t crossoverType, float  mutation, enum delete_t  deletionType, 
	    int elitismValue, enum fitness_t  fitnessType, eval_t  fitnessParam, 
	    int seed);

void setCrossoverProbability(type_TSP_GA* this, float );
void setMutationProbability(type_TSP_GA* this, float );
void setElitismValueu(type_TSP_GA* this, float );
void setRandomSeed(type_TSP_GA* this, int );

type_Chromosome* getBestResult(type_TSP_GA* this) ;

void runTimes(type_TSP_GA* this, unsigned iterationNumber);
void printReport(type_TSP_GA* this);

void replaceWorstChromosomeinTSPWith(type_TSP_GA* thsi, type_Chromosome* newChromo );

int readGenes(type_TSP_GA* this);

void printGenePool(type_TSP_GA* this);
void printPopulation(type_TSP_GA* this);

void disposeTSP_GA(type_TSP_GA* this);

#endif

